#include <PinChangeInterruptHandler.h>
#include <RFReceiver.h>
#include "SensorData.h"

RFReceiver receiver(2);

void setup() {
  Serial.begin(9600);
  pinMode(13, OUTPUT);

  receiver.begin();

  Serial.println("REBOOT");
}

void loop() {
  byte data[MAX_PACKAGE_SIZE];
  byte from = 0;
  byte packageId = 0;
  byte len = receiver.recvPackage(data, &from, &packageId);

  Serial.println("");
  Serial.print("Package: ");
  Serial.println(packageId);
  Serial.println("");

  digitalWrite(13, HIGH);
  SensorData *sensorData = (SensorData *)data;
  Serial.print("Unloaded Voltage: ");
  Serial.println(sensorData->unloadedVcc);
  Serial.print("Loaded Voltage: ");
  Serial.println(sensorData->vcc);
  Serial.print("DHT: ");
  Serial.print(sensorData->dht.humidity);
  Serial.print("% ");
  Serial.print(sensorData->dht.temperature);
  Serial.println(" C");
  Serial.println("Dallas Temperatures:");
  for (int i = 0; i < sensorData->dallasCount; ++i) {
    Serial.print("\t");
    Serial.print(sensorData->dallas[i].temperature);
    Serial.println(" C");
  }
  delay(10);
  digitalWrite(13, LOW);

  // print raw data
  Serial.print("Data: ");
  Serial.print(from >> 4, HEX);
  Serial.print(from & 0xF, HEX);
  Serial.print(packageId >> 4, HEX);
  Serial.print(packageId & 0xF, HEX);
  
  for (int i = 0; i < len; ++i) {
    Serial.print(data[i] >> 4, HEX);
    Serial.print(data[i] & 0xF, HEX);
  }
  
  Serial.println("");
}
